extends KinematicBody

var gravity:float = -9.8
var friction:float = 0.99
var velocity:Vector3
var move_dir:Vector3
export var move_speed:float = 0.0
export var jump_speed:float = 0.0

func _physics_process(delta):
	velocity += move_dir * move_speed * delta
	velocity *= friction
	velocity.y += gravity * delta
	velocity = move_and_slide_with_snap(velocity, get_floor_normal(), Vector3.UP)

func _input(event):
	if event.is_action_pressed("move_up"):
		move_dir.z = -1.0
	if event.is_action_pressed("move_down"):
		move_dir.z = 1.0
	if event.is_action_released("move_up") or event.is_action_released("move_down"):
		move_dir.z = 0.0
		
	if event.is_action_pressed("move_left"):
		move_dir.x = -1.0
	elif event.is_action_pressed("move_right"):
		move_dir.x = 1.0
	if event.is_action_released("move_left") or event.is_action_released("move_right"):
		move_dir.x = 0.0

	if event.is_action_pressed("jump"):
		velocity.y = jump_speed
